10 bsz%    = 10:           REMark Desired Block size (1..13..)
11 speed   =  6:           REMark Speed of animation 0..255. Small is fast
12 lng     = LANGUAGE:     REMark Auto language selection
13 papc    =  1:           REMark Paper colour
14 inkc    =  2:           REMark Message colour
15 :
100 REMark ***         Language dependent message
102 SELect ON lng
104  = 33: str$ = 'JOYEUX NO{L!': REMark Special E omlaut
106  = 39: str$ = 'BUON NATALE!'
108  = 44: str$ = 'MERRY CHRISTMAS!'
110  = 49: str$ = 'FR|HLICHE WEIHNACHTEN!': REMark Re-positioned 
112 END SELect
114 tl% = LEN(str$)
116 :
118 REMark ***         In-built fount or via commandline
120 CLCHP: bf_fa = 0: fnm$ = CMD$
122 IF LEN(fnt$) > 0 THEN
124  fc = FOP_IN(fnm$)
126  IF fc > 0 THEN
128   fl = FLEN(#fc): CLOSE#fc
130   bf_fa = ALCHP(fl): LBYTES fnm$, bf_fa
132  END IF
134 END IF
136 IF bf_fa = 0: bf_fa = FntSet
138 :
140 REMark ***         Init and Scale
142 ch = FOPEN("con")
144 wsx% = SCR_XLIM(#ch): wsy% = SCR_YLIM(#ch)
146 WINDOW#ch; wsx%, wsy%, 0, 0
148 CHAR_USE#ch; bf_fa, 0: PAPER#ch; 1: CLS#ch
150 IF (bsz% * (tl% + 2) * 8) > wsx%: bsz% = INT(wsx%/ 8/ (tl% + 2))
152 RANDOMISE DATE
154 BFInit#ch; bsz%: PRINT#ch; bsz%
156 wcx% = INT((bf_lln% - tl%) / 2): wcy% = INT(bf_lhi% / 2)
158 :
160 REMark ***         Repeat
162 REPeat again
164 DIM text%(bf_lln%, bf_lhi%): str% = 0
166 :
168 REMark ***         Main animation loop
170 REPeat main
172  bf_cx% = RND(0 TO bf_lln%): bf_cy% = RND(0 TO bf_lhi%)
174  IF bf_cy% = wcy% AND bf_cx% > wcx% AND bf_cx% <= (wcx% + tl%) THEN
176   k$ = str$(bf_cx% - wcx%): k% = CODE(k$): alf% = 255:
178   col = RND(0 TO 7): IF col = papc: col = inkc
180   IF text%(bf_cx%, bf_cy%) = 0: str% = str% + 1
182  ELSE
184   k% = RND(65 TO 90): k$ = CHR$(k%): col = RND(0 TO 7)
186   IF col = inkc: alf% = RND(2 TO 220): ELSE : alf% = RND(2 TO 255)
188  END IF
190  IF text%(bf_cx%, bf_cy%) THEN
192   ALPHA_BLEND#ch; 255: BFBlank bf_cx%, bf_cy%, papc
194  END IF
196  text%(bf_cx%, bf_cy%) = k%
198  ALPHA_BLEND#ch; alf%: BFChar k$, bf_cx%, bf_cy%, col
200  IF str% = tl% OR Wait(speed): BEEP 2, 2: EXIT main
202 END REPeat main
204 :
206 REMark ***         Fade-in and out
208 bf_cy% = wcy%
210 FOR i = inkc, 0 TO 6
212  IF i = papc: NEXT i: EXIT i
214  IF Fade(i) OR Fade(papc): EXIT again
216 END FOR i
218 IF Fade(7): EXIT again
220 FOR alf% = 2 TO 255 STEP 2
222  ALPHA_BLEND#ch; alf%: BLOCK#ch; wsx%, wsy%, 0, 0, papc
224 END FOR alf%
226 END REPeat again
228 QUIT
230 :
232 DEFine FuNction Fade(col)
234 REMark Sub-routine under main
236 FOR alf% = 2 TO 250 STEP 5
238  bf_cx% = wcx% + 1
240  ALPHA_BLEND#ch; alf%: BFPrint str$, col
242  IF Wait(1) < 0: RETurn 1
244 END FOR alf%
246 RETurn 0
248 END DEFine Fade
250 :
252 REMark ***         BF - Simplified Block Fount routines
254 DEFine PROCedure BFInit(ch, bsz%)
256 bf_ch   = ch
258 bf_csx% = bsz% * 8
260 bf_csy% = bsz% * 9
262 bf_lln% = INT(wsx% / bf_csx%) - 1
264 bf_lhi% = INT(wsy% / bf_csy%) - 1
266 bf_cx%  = 0: bf_cy% = 0
268 bf_bsz%  = bsz%
270 END DEFine BFInit
272 :
274 DEFine PROCedure BFChar(k$, atx%, aty%, col)
276 LOCal i, c%, r%, k%, ax%, ay%, ca
278 k% = CODE(k$)
280 ca = bf_fa + 2 - (PEEK(bf_fa) - k%) * 9
282 ax% = atx% * bf_csx% + bf_bsz%: ay% = aty% * bf_csy% + bf_bsz%
284 FOR i = 0 TO 8
286  r% = PEEK(ca + i)
288  FOR  c% = 0 TO 7
290   IF BTST%(r%, c%) THEN
292    BLOCK#bf_ch; bf_bsz%, bf_bsz%, ax% + (7 - c%) * bf_bsz%, ay% + i * bf_bsz%, col
294   END IF
296  END FOR c%
298 END FOR i
300 END DEFine BFChar
302 :
304 DEFine PROCedure BFBlank(atx%, aty%, col)
306 BLOCK#bf_ch; bf_csx%, bf_csy%, atx% * bf_csx%, aty% * bf_csy%, col
308 END DEFine BFBlank
310 :
312 DEFine PROCedure BFPrint(str$, col)
314 LOCal i%
316 FOR i% = 1 TO LEN(str$)
318  BFChar str$(i%), bf_cx%, bf_cy%, col
320  bf_cx% = bf_cx% + 1
322 END FOR i%
324 END DEFine BFPrint
326 :
328 REMark ***         Misc & Data
330 DEFine FuNction BTST%(flg%, btn%): RETurn (2 ^ btn% && flg%) <> 0: END DEFine
332 :
334 DEFine FuNction Wait(w%)
336 LOCal kc%
338 kc% = CODE(INKEY$(#ch; w%))
340 SELect ON kc%
342  = 10: PAUSE#ch
344  = 27: RETurn -1
346 END SELect
348 RETurn 0
350 END DEFine Wait
352 :
900 DEFine FuNction FntSet
901 LOCal dad
902 dad = ALCHP(849)
903 POKE dad + 0, " ^",0,0,0,0,0,0,0,0,0,16,16,16,16,16,0,16,0,0,"((",0,0,0,0,0,0,0,"((|(|((",0,0,"8P"
904 POKE dad + 40, "P8",20,20,"8",0,0,"dd",8,16," LL",0,0," PP TH4",0,0,16,16,0,0,0,0,0,0,0,4,8,16,16,16,8
905 POKE dad + 80, 4,0,0,"@ ",16,16,16," @",0,0,16,"T8",16,"8T",16,0,0,0,16,16,"|",16,16,0,0,0,0,0,0,0,0,24,24,8,16,0
906 POKE dad + 120, 0,0,"|",0,0,0,0,0,0,0,0,0,0,24,24,0,0,4,4,8,16," @@",0,0,"8DLTdD8",0,0,16,"0",16,16,16
907 POKE dad + 160, 16,"8",0,0,"8D",4,8,16," |",0,0,"8D",4,24,4,"D8",0,0,8,24,"(H|",8,8,0,0,"|@x",4,4,"D8",0,0
908 POKE dad + 200, 24," @xDD8",0,0,"|",4,8,16," @@",0,0,"8DD8DD8",0,0,"8DD<",4,8,"0",0,0,0,0,24,24
909 POKE dad + 240, 0,24,24,0,0,0,0,24,24,0,24,24,8,16,4,8,16," ",16,8,4,0,0,0,0,"|",0,"|",0,0,0,0,"@ ",16,8,16," @",0
910 POKE dad + 280, 0,"8D",4,8,16,0,16,0,0,"8D\T\@8",0,0,"8DD|DDD",0,0,"xDDxDDx",0,0,"8D@"
911 POKE dad + 320, "@@D8",0,0,"xDDDDDx",0,0,"|@@x@@|",0,0,"|@@x@@@",0,0,"8D@@LD8"
912 POKE dad + 360, 0,0,"DDD|DDD",0,0,"8",16,16,16,16,16,"8",0,0,4,4,4,4,4,"D8",0,0,"DHP`PHD",0,0,"@@"
913 POKE dad + 400, "@@@@|",0,0,"DlTDDDD",0,0,"DDdTLDD",0,0,"8DDDDD8",0,0,"xDDx@@"
914 POKE dad + 440, "@",0,0,"8DDDTH4",0,0,"xDDxPHD",0,0,"8D@8",4,"D8",0,0,"|",16,16,16,16,16,16,0,0,"D"
915 POKE dad + 480, "DDDDD8",0,0,"DDDDD(",16,0,0,"DDDDTT(",0,0,"DD(",16,"(DD",0,0,"DD(",16,16
916 POKE dad + 520, 16,16,0,0,"|",4,8,16," @|",0,0,28,16,16,16,16,16,28,0,0,"@@ ",16,8,4,4,0,0,"p",16,16,16,16,16,"p",0,0
917 POKE dad + 560, 16,"(D",0,0,0,0,0,0,0,0,0,0,0,0,0,"|",0,24,"$ p  |",0,0,0,0,"4LDL4",0,0,"@@xD"
918 POKE dad + 600, "DDx",0,0,0,0,"<@@@<",0,0,4,4,"<DDD<",0,0,0,0,"8D|@<",0,0,8,20,16,"8",16,16,16,0
919 POKE dad + 640, 0,0,0,"8DDD<",4,"8@@xDDDD",0,0,16,0,16,16,16,16,8,0,0,16,0,16,16,16,16,16,16," @@D"
920 POKE dad + 680, "HPhD",0,0,16,16,16,16,16,16,8,0,0,0,0,"hTTTT",0,0,0,0,"xDDDD",0,0,0,0,"8DDD8"
921 POKE dad + 720, 0,0,0,0,"xDDDx@@",0,0,"<DDD<",4,4,0,0,"Xd@@@",0,0,0,0,"8@8",4,"8",0,0,16,16
922 POKE dad + 760, "8",16,16,16,12,0,0,0,0,"DDDD<",0,0,0,0,"DDD(",16,0,0,0,0,"DDDT(",0,0,0,0,"D(",16,"("
923 POKE dad + 800, "D",0,0,0,0,"DDDD<",4,"8",0,0,"|",8,16," |",0,0,"(",0,"|@|@|",0,0,"D8DDDD8",0,0," "
924 POKE dad + 840, 16,16,8,16,16," ",0,0,20,0
925 RETurn dad
926 END DEFine FntSet
927 :
